unit UMainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, IniFiles, Math, ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox3: TGroupBox;
    cmbHintingMode: TComboBox;
    cmbAntiAliasMode: TComboBox;
    chkUseMapping: TCheckBox;
    chkFontLink: TCheckBox;
    cmbFontSubstitutes: TComboBox;
    cmbWidhMode: TComboBox;
    cmbFontLoader: TComboBox;
    cmbBolderMode: TComboBox;
    trkContrast: TTrackBar;
    trkNormalWeight: TTrackBar;
    trkBoldWeight: TTrackBar;
    trkItalicSlant: TTrackBar;
    cmbLcdFilter: TComboBox;
    GroupBox1: TGroupBox;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    trkTextTuning: TTrackBar;
    trkTextTuningR: TTrackBar;
    trkTextTuningG: TTrackBar;
    trkTextTuningB: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    GroupBox2: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    cmbGammaMode: TComboBox;
    trksRGB: TTrackBar;
    trkGammaValue: TTrackBar;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    GroupBox4: TGroupBox;
    grp2X: TGroupBox;
    grp4X: TGroupBox;
    btnUpdate: TButton;
    chkRealtimeUpdate: TCheckBox;
    edtSampleText: TEdit;
    Label19: TLabel;
    grpPreview: TGroupBox;
    Label20: TLabel;
    btnChgFont: TButton;
    FontDialog1: TFontDialog;
    pbPreview: TPaintBox;
    pb2XPrev: TPaintBox;
    pb4XPrev: TPaintBox;
    Label21: TLabel;
    Label22: TLabel;
    ColorDialog1: TColorDialog;
    btnFontColor: TButton;
    btnBkColor: TButton;
    procedure FormCreate(Sender: TObject);
    procedure RealtimeUpdate(Sender: TObject);
    procedure edtSampleTextChange(Sender: TObject);
    procedure pbPreviewPaint(Sender: TObject);
    procedure pb2XPrevPaint(Sender: TObject);
    procedure pbPreviewClick(Sender: TObject);
    procedure btnUpdateClick(Sender: TObject);
    procedure btnChgFontClick(Sender: TObject);
    procedure pb4XPrevPaint(Sender: TObject);
    procedure trkBkColorChange(Sender: TObject);
    procedure btnFontColorClick(Sender: TObject);
    procedure btnBkColorClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;
  hDll: Cardinal;

implementation

{$R *.dfm}

var
  drawFont: TFont;

procedure ReadParameters;
var
  ini: TIniFile;
  i: Integer;
begin
  ini := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'gdi++.ini');
  with Form1 do
  begin
    cmbHintingMode.ItemIndex := ini.ReadInteger('General', 'HintingMode', 1);
    cmbAntiAliasMode.ItemIndex := ini.ReadInteger('General', 'AntiAliasMode', 2) + 1;
    chkUseMapping.Checked := ini.ReadBool('General', 'UseMapping', true);
    chkFontLink.Checked := ini.ReadBool('General', 'FontLink', true);
    cmbFontSubstitutes.ItemIndex := ini.ReadInteger('General', 'FontSubstitutes', 2);
    cmbWidhMode.ItemIndex := ini.ReadInteger('General', 'WidthMode', 0);
    cmbFontLoader.ItemIndex := ini.ReadInteger('General', 'FontLoader', 0);
    cmbBolderMode.ItemIndex := ini.ReadInteger('General', 'BolderMode', 0);
    cmbGammaMode.ItemIndex := ini.ReadInteger('General', 'GammaMode', 0);
    trkGammaValue.Position := Floor(ini.ReadFloat('General', 'GammaValue', 2.0)*10);
    trksRGB.Position := Floor(ini.ReadFloat('General', 'sRGB', 2.2)*10);
    trkTextTuning.Position := ini.ReadInteger('General', 'TextTuning', 0);
    trkTextTuningR.Position := ini.ReadInteger('General', 'TextTuningR', -1);
    trkTextTuningG.Position := ini.ReadInteger('General', 'TextTuningG', -1);
    trkTextTuningB.Position := ini.ReadInteger('General', 'TextTuningB', -1);
    trkNormalWeight.Position := Ini.ReadInteger('General', 'NormalWeight', 0);
    trkBoldWeight.Position := Ini.ReadInteger('General', 'BoldWeight', 0);
    trkItalicSlant.Position := Ini.ReadInteger('General', 'ItalicSlant', 0);
    i := Ini.ReadInteger('General', 'LcdFilter', 2);
    if i = 16 then
      cmbLcdFilter.ItemIndex := 3
    else
      cmbLcdFilter.ItemIndex := i;
  end;
  ini.Free;
end;

procedure WriteParameters;
var
  ini: TIniFile;
begin
  ini := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'gdi++.ini');
  with Form1 do
  begin
    ini.WriteInteger('General', 'HintingMode', cmbHintingMode.ItemIndex);
    ini.WriteInteger('General', 'AntiAliasMode', cmbAntiAliasMode.ItemIndex - 1);
    ini.WriteBool('General', 'UseMapping', chkUseMapping.Checked);
    ini.WriteBool('General', 'FontLink', chkFontLink.Checked);
    ini.WriteInteger('General', 'FontSubstitutes', cmbFontSubstitutes.ItemIndex);
    ini.WriteInteger('General', 'WidthMode', cmbWidhMode.ItemIndex);
    ini.WriteInteger('General', 'FontLoader', cmbFontLoader.ItemIndex);
    ini.WriteInteger('General', 'BolderMode', cmbBolderMode.ItemIndex);
    ini.WriteInteger('General', 'GammaMode', cmbGammaMode.ItemIndex);
    ini.WriteFloat('General', 'GammaValue', trkGammaValue.Position / 10);
    ini.WriteFloat('General', 'sRGB', trksRGB.Position / 10);
    ini.WriteInteger('General', 'TextTuning', trkTextTuning.Position);
    ini.WriteInteger('General', 'TextTuningR', trkTextTuningR.Position);
    ini.WriteInteger('General', 'TextTuningG', trkTextTuningG.Position);
    ini.WriteInteger('General', 'TextTuningB', trkTextTuningB.Position);
    ini.WriteInteger('General', 'NormalWeight', trkNormalWeight.Position);
    ini.WriteInteger('General', 'BoldWeight', trkBoldWeight.Position);
    ini.WriteInteger('General', 'ItalicSlant', trkItalicSlant.Position);
    if cmbLcdFilter.ItemIndex = 3 then
      ini.WriteInteger('General', 'LcdFilter', 16)
    else
            ini.WriteInteger('General', 'LcdFilter', cmbLcdFilter.ItemIndex);
  end;
  ini.Free;
end;

procedure UpdatePreview;
begin
  with Form1 do
  begin
    pbPreview.Invalidate;
    pb2XPrev.Invalidate;
    pb4XPrev.Invalidate;
  end;
end;

procedure UpdateGdiXX;
begin
  FreeLibrary(hDll);
  WriteParameters;
  LoadLibrary('gdi++.dll');
  Sleep(1);
  UpdatePreview;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ReadParameters;
  UpdatePreview;
end;

procedure TForm1.RealtimeUpdate(Sender: TObject);
begin
  if chkRealtimeUpdate.Checked then
  begin
    UpdateGdiXX;
  end;
end;

procedure TForm1.edtSampleTextChange(Sender: TObject);
begin
  UpdatePreview;
end;

procedure TForm1.pbPreviewPaint(Sender: TObject);
begin
  drawFont.Assign(FontDialog1.Font);
  drawFont.Color := btnFontColor.Tag;
  pbPreview.Font := drawFont;
  pbPreview.Canvas.Brush.Color := btnBkColor.Tag;
  pbPreview.Canvas.FillRect(pbPreview.ClientRect);
  pbPreview.Canvas.TextOut(0, 0, edtSampleText.Text);
  //TextOut(pbPreview.Canvas.Handle, 0, 0, PChar(edtSampleText.Text), Length(edtSampleText.Text));
end;

procedure TForm1.pb2XPrevPaint(Sender: TObject);
begin
  // 2x
  StretchBlt(pb2XPrev.Canvas.Handle, 0, 0, pb2XPrev.ClientWidth, pb2XPrev.ClientHeight,
      pbPreview.Canvas.Handle, HiWord(pb2XPrev.Tag), LoWord(pb2XPrev.Tag),
      pb2XPrev.ClientWidth div 8, pb2XPrev.ClientHeight div 8, SRCCOPY);
end;

procedure TForm1.pb4XPrevPaint(Sender: TObject);
begin
  // 4x
  StretchBlt(pb4XPrev.Canvas.Handle, 0, 0, pb4XPrev.ClientWidth, pb4XPrev.ClientHeight,
      pbPreview.Canvas.Handle, HiWord(pb4XPrev.Tag), LoWord(pb4XPrev.Tag),
      pb4XPrev.ClientWidth div 16, pb4XPrev.ClientHeight div 16, SRCCOPY);
end;

procedure TForm1.pbPreviewClick(Sender: TObject);
var
  p: TPoint;
begin
  p := pbPreview.ScreenToClient(Mouse.CursorPos);
  pb2XPrev.Tag := MakeLong(p.Y, p.X);
  pb4XPrev.Tag := MakeLong(p.Y, p.X);
  UpdatePreview;
end;

procedure TForm1.btnUpdateClick(Sender: TObject);
begin
  UpdateGdiXX;
end;

procedure TForm1.btnChgFontClick(Sender: TObject);
begin
  if FontDialog1.Execute then
  begin
    btnChgFont.Font.Style := FontDialog1.Font.Style;
    btnChgFont.Font.Name := FontDialog1.Font.Name;
    btnChgFont.Caption := FontDialog1.Font.Name + ' (' + IntToStr(FontDialog1.Font.Size) + ')';
    UpdatePreview;
  end;
end;

procedure TForm1.trkBkColorChange(Sender: TObject);
begin
  UpdatePreview;
end;

procedure TForm1.btnFontColorClick(Sender: TObject);
begin
  if ColorDialog1.Execute then
  begin
    btnFontColor.Tag := ColorDialog1.Color;
    btnFontColor.Caption := IntToHex(ColorDialog1.Color, 6);
    UpdatePreview;
  end;
end;

procedure TForm1.btnBkColorClick(Sender: TObject);
begin
  if ColorDialog1.Execute then
  begin
    btnBkColor.Tag := ColorDialog1.Color;
    btnBkColor.Caption := IntToHex(ColorDialog1.Color, 6);
    UpdatePreview;
  end;
end;


initialization
  drawFont := TFont.Create;

finalization
  drawFont.Free;

end.
